import logging.config
from box.argparse import Program
from .create import create
from .settings import settings


class program(Program):

    # Public

    default_config = settings.argparse  # override

    def __call__(self):
        self.__init_logging()
        self.__execute()

    # Protected

    def __init_logging(self):
        logging.config.dictConfig(settings.logging)
        logger = logging.getLogger()
        if self.debug:
            logger.setLevel(logging.DEBUG)
        if self.verbose:
            logger.setLevel(logging.INFO)
        if self.quiet:
            logger.setLevel(logging.ERROR)

    def __execute(self):
        create(self._command.path,
            pattern=self._command.pattern,
            command=self._command.command)
